#ifndef _MINIDAEMON_H
#define _MINIDAEMON_H 1

#define MD_USR_ERROR(msg) \
		fprintf(stderr,"%s\n",msg); exit(1);

#define MD_SYS_ERROR(msg) \
		perror(msg); exit(1);

/**
Minidaemon ADT  provided by Mellanox, MPI Team

Minidaemon interface provides the possibilty to create and run
daemon process on clusters node. Each instance of it will be created 
at application run time and will destroyed right after application termination.
**/
typedef enum {
    P_NOTSTARTED,
    P_STARTED,
    P_CONNECTED,
    P_DISCONNECTED,
    P_RUNNING,
    P_FINISHED,
    P_EXITED
} process_state;

struct process_t {
    char *hostname;
    char *device;
    int pid;
    int port;
    int control_socket;
    process_state state;
} ;

// Minidaemon Data Structures

typedef struct childrenList_t * ChildrenList;
typedef struct md_entry_t * MD_entry;
typedef struct minidaemon_t * Minidaemon;
typedef struct process_t process;

void minidaemon_create(process * procList, int nproc, int width,const char * command_params,const char * command);

// Init all data member structures
void minidaemon_init ( const char * par_name , int ch_num, int width, const char * command_params,const char * command);

// Start listening to messages from other Minidaemons
void minidaemon_run ();


#endif // _MINIDAEMON_H
